export type FunctionContext<TFunc extends (this: any, ...args: any[]) => any = (this: any, ...args: any[]) => any> = {
    func: TFunc;
    funcWrapper: TFunc;
    funcArgs: Parameters<TFunc>;
    funcThis?: ThisParameterType<TFunc>;
    funcOutcome?: FunctionExecutionOutcome<TFunc>;
};
export type FunctionInterceptors<TFunc extends (this: any, ...args: any[]) => any = (...args: any[]) => any, TContext extends {} = {}> = {
    onTry: (ctx: FunctionContext<TFunc>) => {
        context?: TContext;
        onCatch?: (ctx: TContext & FunctionContext<TFunc>) => void;
        onFinally?: (ctx: TContext & FunctionContext<TFunc>) => void;
    };
    onCatch?: (ctx: TContext & FunctionContext<TFunc>) => void;
    onFinally?: (ctx: TContext & FunctionContext<TFunc>) => void;
};
export declare function createTryCatchFinally<TFunc extends (this: any, ...args: any[]) => any, TContext extends {}>(func: TFunc, interceptors: FunctionInterceptors<TFunc, TContext>): TFunc;
export type FunctionExecutionOutcome<TFunc extends (...args: any[]) => any> = {
    type: 'success';
    result: Awaited<ReturnType<TFunc>>;
} | {
    type: 'error';
    error: any;
};
//# sourceMappingURL=tryCatchFinally.d.ts.map